package hideandseek.managers;

import org.bukkit.event.EventHandler;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.event.player.PlayerJoinEvent;
import java.util.Iterator;
import org.bukkit.entity.Player;
import java.io.IOException;
import hideandseek.utils.Utils;
import java.io.Reader;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;
import org.bukkit.plugin.Plugin;
import hideandseek.HideAndSeek;
import org.bukkit.Bukkit;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import org.bukkit.event.Listener;

public class NotificationsManager implements Listener
{
    private final String pluginName = "HideAndSeek";
    private final String permission = "hideandseek.admin";
    private final long fetchInterval = 21600000L;
    private final long notificationInterval = 21600000L;
    private boolean notificationAvailable;
    private final List<String> messages;
    private long lastCheck;
    private final HashMap<String, Long> notifiedPlayers;
    
    public NotificationsManager() {
        this.messages = new ArrayList<String>();
        this.lastCheck = 0L;
        this.notifiedPlayers = new HashMap<String, Long>();
        Bukkit.getPluginManager().registerEvents((Listener)this, (Plugin)HideAndSeek.getInstance());
    }
    
    public void fetch() {
        this.lastCheck = System.currentTimeMillis();
        try {
            final BufferedReader var1 = new BufferedReader(new InputStreamReader(new URL("").openStream()));
            this.notificationAvailable = false;
            String var2 = var1.readLine();
            final String var3 = var2.replace("enabled-plugins: ", "").toLowerCase();
            if (var3.contains("all_plugins") || var3.contains("HideAndSeek".toLowerCase())) {
                this.notificationAvailable = true;
            }
            if (!this.notificationAvailable) {
                return;
            }
            this.messages.clear();
            while ((var2 = var1.readLine()) != null) {
                this.messages.add(Utils.colorize(var2).replace("%permission%", "hideandseek.admin").replace("%plugin%", "HideAndSeek"));
            }
        }
        catch (final IOException var4) {
            this.notificationAvailable = false;
        }
    }
    
    public void notifyPlayer(final Player var1) {
        if (this.notificationAvailable && System.currentTimeMillis() - this.notifiedPlayers.getOrDefault(var1.getName(), 0L) >= 21600000L) {
            this.notifiedPlayers.put(var1.getName(), System.currentTimeMillis());
            for (final String var3 : this.messages) {
                var1.sendMessage(var3);
            }
        }
    }
    
    @EventHandler
    public void onPlayerJoinEvent(final PlayerJoinEvent var1) {
        final Player var2 = var1.getPlayer();
        if (var2.hasPermission("hideandseek.admin")) {
            if (this.lastCheck != 0L && System.currentTimeMillis() - this.lastCheck < 21600000L) {
                this.notifyPlayer(var2);
            }
            else {
                new BukkitRunnable() {
                    public void run() {
                        NotificationsManager.this.fetch();
                        NotificationsManager.this.notifyPlayer(var2);
                    }
                }.runTaskAsynchronously((Plugin)HideAndSeek.getInstance());
            }
        }
    }
}
